<?php
namespace Controller;

use Zeedhi\Framework\DTO\Response\Message;
use Zeedhi\Framework\DTO\Response\Error;
use Zeedhi\Framework\DTO\Response;
use Zeedhi\Framework\DTO\Request;

class Register extends \Zeedhi\Framework\Controller\Simple {
    
    protected $profileService;
    protected $util;

    public function __construct(\Service\Register $registerService, \Util\Util $util){
        $this->registerService = $registerService;
        $this->util = $util;
    }
    
    public function registerUser(Request\Filter $request, Response $response){
        try{
            $params = $request->getFilterCriteria()->getConditions();
        
            $userData = $params[0]['value'][0];
            $sonsData = $params[1]['value'];
            
            $userData['NRCPFRESPCON'] = str_replace('.', '', $userData['NRCPFRESPCON']);
			$userData['NRCPFRESPCON'] = str_replace('-', '', $userData['NRCPFRESPCON']);
			$userData['NMMUNICIPIO'] = iconv('UTF-8', 'ISO-8859-1//TRANSLIT//IGNORE', $userData['NMMUNICIPIO']);
			$this->registerValidation($userData);
            $userData['CDSENHACONSMD5'] = $this->util->encrypt($userData['CDSENHACONSMD5']);
            $userData['CDTIPOCONS'] = $this->registerService->getCDTIPOCONS($userData['CDFILIAL']);
			$userData['CDCCUSCLIE'] = $this->registerService->getCDCCUSCLIE($userData['CDFILIAL']);
			
			$userData['NRCELULARCONS'] = str_replace('(', '', $userData['NRCELULARCONS']);
            $userData['NRCELULARCONS'] = str_replace(')', '', $userData['NRCELULARCONS']);
            $userData['NRCELULARCONS'] = str_replace('-', '', $userData['NRCELULARCONS']);
            $userData['NRCELULARCONS'] = str_replace(' ', '', $userData['NRCELULARCONS']);
            
            if(!empty($userData['NRTELECONS'])){
                $userData['NRTELECONS'] = str_replace('(', '', $userData['NRTELECONS']);
                $userData['NRTELECONS'] = str_replace(')', '', $userData['NRTELECONS']);
                $userData['NRTELECONS'] = str_replace('-', '', $userData['NRTELECONS']);
                $userData['NRTELECONS'] = str_replace(' ', '', $userData['NRTELECONS']);
            }
			
			$userData['CDPAIS'] = '0055';
    		$userData['IDATUCONSUMI'] = 'S';
    		$userData['IDSITCONSUMI'] = '1'; //ativo
    		$userData['IDCONSUMIDOR'] = 'C';
    		$userData['CDVENDEDOR'] = '';
    		$userData['IDTPVENDACONS'] = '7';
    		$userData['IDIMPCPFCUPOM'] = 'S';
    		$userData['IDCADCONFLIBCON'] = 'N';
    		$userData['IDPERCONSPRODEX'] = 'S';
    		$userData['IDTPSELMANHA'] = 'N';
    		$userData['IDTPSEALMOCO'] = 'N';
    		$userData['IDTPSELTARDE'] = 'N';
    		$userData['IDCRACHAMESTRE'] = 'S';
            foreach($sonsData as $key => $son){
                $this->consumerValidation($son,$userData['CDCLIENTE']);
                $CDCONSUMIDOR = $this->util->newCode('CONSUMIDOR'.$userData['CDCLIENTE'], 18);
                $CDCONSUMIDOR = 'NCS' . $CDCONSUMIDOR;
                $this->registerService->registerUser($son, $userData, $CDCONSUMIDOR);
            }
            
            $return['error'] = false;
            $return['message'] = 'Cadastro realizado com sucesso';
            $response->addDataSet(new \Zeedhi\Framework\DataSource\DataSet('RegisterUserRepository', $return));
        } catch(\Exception $e){
            $return['error'] = true;
            $return['message'] = $e->getMessage();
            $response->addDataSet(new \Zeedhi\Framework\DataSource\DataSet('RegisterUserRepository', $return));
        }
    }
    
    public function registerValidation($userData){
		$consumer = $this->registerService->getConsumerByLogin($userData['NMLOGINCONS'], $userData['CDCLIENTE']);
		if (!Empty($consumer)){
			throw new \Exception("Login indisponível.");
		}
		
		$consumer = $this->registerService->getConsumerByCPF($userData['NRCPFRESPCON'],$userData['CDCLIENTE']);
		if (!Empty($consumer)){
			throw new \Exception("CPF já se encontra cadastrado no sistema.");
		}
		
		
	}
	
	public function consumerValidation($son, $cdCliente){
	    $consumer = $this->registerService->getConsumerById($son['CDIDCONSUMID'], $cdCliente);
	    if(!Empty($consumer)){
	    	throw new \Exception("Matricula {$son['CDIDCONSUMID']} já se encontra cadastrada no sistema.");
	    }
	}

}