<?php
namespace Zeedhi\PaymentPlatform\Implementations\Santander;

class santanderBoleto{

    public function __construct() {

    }

    /*
        Script de geraBoleto
    */

    public function createEntry($key, $value) {
        $toReturn = array('key'   => $key,
                        'value' => $value);
        return $toReturn;
    }

    public function getTicketXml($banco, $consumidor, $venda, $boleto) {
        $dados = array($this->createEntry('CONVENIO.COD-BANCO', '0033'),
                        $this->createEntry('CONVENIO.COD-CONVENIO', '0585777'), //INSERIR O CÓDIGO DO CONVÊNIO(CEDENTE)

                        $this->createEntry('PAGADOR.TP-DOC', '01'),  // 01 = CPF 02 = CNPJ
                        $this->createEntry('PAGADOR.NUM-DOC', $consumidor['NRCPFRESPCON']),
                        $this->createEntry('PAGADOR.NOME', $consumidor['NMCONSUMIDOR']),
                        $this->createEntry('PAGADOR.ENDER', $consumidor['DSENDECONS']),
                        $this->createEntry('PAGADOR.BAIRRO', $consumidor['NMBAIRCONS']),
                        $this->createEntry('PAGADOR.CIDADE', $consumidor['NMMUNICIPIO']),
                        $this->createEntry('PAGADOR.UF', $consumidor['SGESTADO']),
                        $this->createEntry('PAGADOR.CEP', str_replace('-', '', $consumidor['NRCEPCONS'])),

                        $this->createEntry('TITULO.NOSSO-NUMERO', $boleto['bankNumber']),
                        $this->createEntry('TITULO.SEU-NUMERO', $boleto['nossoNumero']),
                        $this->createEntry('TITULO.DT-VENCTO', str_replace('/', '', $venda['DATAVENC'])),
                        $this->createEntry('TITULO.DT-EMISSAO', $venda['DATAEMIS']), //INSERIR DATA DO DIA DO REGISTRO (EX: 12/07/2018 -> 12072018)
                        $this->createEntry('TITULO.ESPECIE', '02'),                        //FIXO
                        $this->createEntry('TITULO.VL-NOMINAL', $venda['PRICETAG']),
                        $this->createEntry('TITULO.PC-MULTA', '000'),           //////
                        $this->createEntry('TITULO.QT-DIAS-MULTA', '00'),       //////
                        $this->createEntry('TITULO.PC-JURO', '000'),            //////
                        $this->createEntry('TITULO.TP-DESC', '0'),              //////
                        $this->createEntry('TITULO.VL-DESC', '000'),            //////
                        $this->createEntry('TITULO.DT-LIMI-DESC', '00000000'),  //////
                        $this->createEntry('TITULO.VL-DESC2', '000'),           //////
                        $this->createEntry('TITULO.DT-LIMI-DESC2', '00000000'), //////
                        $this->createEntry('TITULO.VL-DESC3', '000'),           //////
                        $this->createEntry('TITULO.DT-LIMI-DESC3', '00000000'), //////
                        $this->createEntry('TITULO.VL-ABATIMENTO', '000'),      //////
                        $this->createEntry('TITULO.TP-PROTESTO', '0'),          //////
                        $this->createEntry('TITULO.QT-DIAS-PROTESTO', '00'),    //////
                        $this->createEntry('TITULO.QT-DIAS-BAIXA', '1'),        //////
                        $this->createEntry('TITULO.TP-PAGAMENTO', '1'),                    //FIXO
                        $this->createEntry('TITULO.QT-PARCIAIS', '00'),                    //FIXO
                        $this->createEntry('TITULO.TP-VALOR', '2'),
                        $this->createEntry('TITULO.VL-PERC-MINIMO', $venda['PRICETAG']),
                        $this->createEntry('TITULO.VL-PERC-MAXIMO', $venda['PRICETAG']),
                        $this->createEntry('TITULO.TP-DOC-AVALISTA', ''),      //////
                        $this->createEntry('TITULO.NUM-DOC-AVALISTA', ''),     //////
                        $this->createEntry('TITULO.NOME-AVALISTA', ''),        //////
                        $this->createEntry('TITULO.COD-PARTILHA1', ''),        //////
                        $this->createEntry('TITULO.VL-PARTILHA1', ''),         //////
                        $this->createEntry('TITULO.COD-PARTILHA2', ''),        //////
                        $this->createEntry('TITULO.VL-PARTILHA2', ''),         //////
                        $this->createEntry('TITULO.COD-PARTILHA3', ''),        //////
                        $this->createEntry('TITULO.VL-PARTILHA3', ''),         //////
                        $this->createEntry('TITULO.COD-PARTILHA4', ''),        //////
                        $this->createEntry('TITULO.VL-PARTILHA4', ''),         //////


                        $this->createEntry('MENSAGEM', 'Favor nao receber apos vencimento nem valor menor que o do documento.')
                    );
        $ticketRequest = array('dados'     => $dados,
                            'expiracao' => 100,
                            'sistema'   => 'YMB');
        $toReturn = array('TicketRequest' => $ticketRequest);
        return $toReturn;
    }

    public function getRegistroXml($ticket, $venda, $boleto) {
        $inclusaoTitulo = array('dtNsu'      => $venda['DATAEMIS'], //INSERIR DATA DO DIA DO REGISTRO (EX: 12/07/2018 -> 12072018)
                                'estacao'    => 'ARLQ', //INSERIR CÓDIGO DA ESTAÇÃO
                                'nsu'        => 'TST' . '012345678' . $venda['DATAEMIS'], //$boleto['nossoNumero'] . $venda['DATAEMIS'], <--- CONFIGURACAO DE PRODUCAO
                                'ticket'     => $ticket,
                                'tpAmbiente' => 'T'
                            );

        $toReturn = array('dto' => $inclusaoTitulo);

        return $toReturn;
    }

    private function handleGenerateBillet ($banco, $dadosBoleto, $dadosCliente, $dadosLoja, $dadosVenda, $obs) {
        $dadosboleto["carteira"] = '102';
        $dadosboleto["bankName"] = 'santander';

        $prazoPagamento = $dadosBoleto['prazoPagamento']; //prazo para pagamento a partir do dia da geração
        $valorBoleto    = $dadosBoleto['valor']; //Valor total do boleto
        $nossoNumero    = $dadosBoleto['nossoNumero']; //Número de registro da empresa no banco
        $nrDocumento    = $dadosBoleto['numeroDocumento']; //Número que identifica o boleto

        $nomeCliente    = $dadosCliente['nomeCliente']; //Nome do cliente
        $endereco1      = $dadosCliente['endereco1']; //Endereço do cliente
        $endereco2      = $dadosCliente['endereco2']; //Complemento do endereco do cliente (Cidade/estado/etc)

        $nomeFantasia   = "TEKNISA"; //Nome fantasia da loja
        $site           = "heitor.carvalho@teknisa.com"; //$dadosLoja['siteCliente']; //Site para contato da loja
        $cpfCnpj        = "26.269.316/0001-77"; //$dadosLoja['cpfCnpj']; //Cpf ou CNPJ da loja
        $enderecoLoja   = "Rua Pernambuco, Savassi"; //$dadosLoja['endereco']; //Endereço da loja
        $cidade_uf      = "Belo Horizonte/MG"; //$dadosLoja['cidadeEstado']; //Formato: Cidade/Estado
        $razaoSocial    = "TEKNISA SOFTWARE LTDA"; //$dadosLoja['razaoSocial']; // Razão social da loja

        $agenciaLoja    = $dadosLoja['conta']['agencia']; //Agencia da loja
        $agenciaDvLoja  = $dadosLoja['conta']['digitoAgencia']; //Dígito verificador da agencia
        $contaLoja      = $dadosLoja['conta']['conta']; //Conta da loja
        $contaDvLoja    = $dadosLoja['conta']['digitoConta']; //Dígito verificador da conta

        $data_venc = $dadosVenda['DATAVENC'];  // Prazo de X dias OU informe data: "13/04/2006";
        $valor_boleto = number_format(str_replace(",", ".", $valorBoleto), 2, ',', '');

        $dadosboleto["nosso_numero"] = $nossoNumero;  // Nosso numero sem o DV - REGRA: Máximo de 11 caracteres!
        $dadosboleto["numero_documento"] = $nrDocumento;    // Num do pedido ou do documento
        $dadosboleto["data_vencimento"] = $data_venc; // Data de Vencimento do Boleto - REGRA: Formato DD/MM/AAAA
        $dadosboleto["data_documento"] = date("d/m/Y"); // Data de emissão do Boleto
        $dadosboleto["data_processamento"] = date("d/m/Y"); // Data de processamento do boleto (opcional)
        $dadosboleto["valor_boleto"] = $valor_boleto;   // Valor do Boleto - REGRA: Com vírgula e sempre com duas casas depois da virgula
        $dadosboleto["codigo_banco_com_dv"] = '0033';

        // DADOS DO SEU CLIENTE
        $dadosboleto["sacado"] = $nomeCliente;
        $dadosboleto["endereco1"] = $endereco1;
        $dadosboleto["endereco2"] = $endereco2;

        // INFORMACOES PARA O CLIENTE
        $dadosboleto["demonstrativo1"] = $obs;
        $dadosboleto["demonstrativo2"] = "";
        $dadosboleto["demonstrativo3"] = "";
        $dadosboleto["instrucoes1"] = "- Favor nao receber apos vencimento nem valor menor que o do documento.";
        $dadosboleto["instrucoes2"] = $site;
        $dadosboleto["instrucoes3"] = "";
        $dadosboleto["instrucoes4"] = "";

        // DADOS OPCIONAIS DE ACORDO COM O BANCO OU CLIENTE
        $dadosboleto["quantidade"] = "001";
        $dadosboleto["valor_unitario"] = $valor_boleto;
        $dadosboleto["aceite"] = "";
        $dadosboleto["especie"] = "R$";
        $dadosboleto["especie_doc"] = "DS";

        // Bradesco: todos os campos
        // BB: Só utiliza agencia e conta, sem os dígitos
        // Itaú: não usa dígito da agência
        $dadosboleto["agencia"] = $agenciaLoja; // Num da agencia, sem digito
        $dadosboleto["agencia_dv"] = $agenciaDvLoja; // Digito do Num da agencia
        $dadosboleto["conta"] = $contaLoja;  // Num da conta, sem digito
        $dadosboleto["conta_dv"] = $contaDvLoja;     // Digito do Num da conta

        // DADOS PERSONALIZADOS - Bradesco
        $dadosboleto["conta_cedente"] = ""; // ContaCedente do Cliente, sem digito (Somente Números)
        $dadosboleto["conta_cedente_dv"] = ""; // Digito da ContaCedente do Cliente

        // DADOS PERSONALIZADOS - BB
        /*
        #################################################
        DESENVOLVIDO PARA CARTEIRA 18
        ALERTA: A CARTEIRA FOI TROCADA DE 18 PARA 17 (15/10/2015).

        - Carteira 18 com Convenio de 8 digitos
          Nosso número: pode ser até 9 dígitos

        - Carteira 18 com Convenio de 7 digitos
          Nosso número: pode ser até 10 dígitos

        - Carteira 18 com Convenio de 6 digitos
          Nosso número:
          de 1 a 99999 para opção de até 5 dígitos
          de 1 a 99999999999999999 para opção de até 17 dígitos

        #################################################
        */
        $dadosboleto["convenio"] = "0585777"; //$dadosLoja['convenio'];  // Num do convênio - REGRA: 6 ou 7 ou 8 dígitos
        $dadosboleto["contrato"] = $dadosLoja['contrato']; // Num do seu contrato
        $dadosboleto["formatacao_convenio"] = strlen($dadosLoja['convenio']); // REGRA: 8 p/ Convênio c/ 8 dígitos, 7 p/ Convênio c/ 7 dígitos, ou 6 se Convênio c/ 6 dígitos

        // FORMATACAO NOSSO NUMERO
        // REGRA: Usado apenas p/ Convênio c/ 6 dígitos: informe 1 se for NossoNúmero de até 5 dígitos ou 2 para opção de até 17 dígitos
        if (strlen($dadosLoja['convenio']) == 6) {
            if (strlen($nossoNumero) <= 5) {
                $dadosboleto["formatacao_nosso_numero"] = '1';
            } else {
                $dadosboleto["formatacao_nosso_numero"] = '2';
            }
        }
        // FIM DADOS PERSONALIZADOS BB

        // SEUS DADOS
        $dadosboleto["identificacao"] = $nomeFantasia;
        $dadosboleto["cpf_cnpj"] = $cpfCnpj;
        $dadosboleto["endereco"] = $enderecoLoja;
        $dadosboleto["cidade_uf"] = $cidade_uf;
        $dadosboleto["cedente"] = $razaoSocial;

        $dadosboleto["codigo_cliente"] = $dadosBoleto["codigoCedente"];
        $dadosboleto["ponto_venda"] = $agenciaLoja;
        $dadosboleto["carteira_descricao"] = "COBRANÇA SIMPLES - CSR";

        return $dadosboleto;
    }

    public function geraBoleto($paramsBank, $paramsConsumer, $paramsSale, $paramsBillet, $paramsClient, $paramsStore, $obs = '') {
        try{$options = array(
                'cache_wsdl'     => 0,
                'trace'          => 1,
                //'proxy_host'     => '192.168.122.121',
                //'proxy_port'     => '3128',
                'local_cert'     => '/var/www/workfolder/14994019_out.pem', // substituir pelo caminho do certificado
                'passphrase'     => '21960650',   // substituir pela senha do certificado
                'stream_context' => stream_context_create(array(
                    'ssl' => array(
                        'verify_peer' => false,
                        'verify_peer_name' => false,
                        'allow_self_signed' => true
                    )
                ))
            );

            $cliTicket = new \SoapClient('https://ymbdlb.santander.com.br/dl-ticket-services/TicketEndpointService/TicketEndpointService.wsdl', $options);
            //echo ("CHAMANDO O DLB TICKET!!");
            // ticket
            
            //Calcula dígito de controle do número do banco
            $bankNumberSum = ($paramsBillet['nossoNumero'][11] * 2) + ($paramsBillet['nossoNumero'][10] * 3) + ($paramsBillet['nossoNumero'][9] * 4) + ($paramsBillet['nossoNumero'][8] * 5) + ($paramsBillet['nossoNumero'][7] * 6) + ($paramsBillet['nossoNumero'][6] * 7) + ($paramsBillet['nossoNumero'][5] * 8) + ($paramsBillet['nossoNumero'][4] * 9) + ($paramsBillet['nossoNumero'][3] * 2) + ($paramsBillet['nossoNumero'][2] * 3) + ($paramsBillet['nossoNumero'][1] * 4) + ($paramsBillet['nossoNumero'][0] * 5);
            
            $bankNumberRest = (int)($bankNumberSum / 11);
            
            $bankNumberRest = $bankNumberSum - ($bankNumberRest * 11);
            
            if($bankNumberRest === 0 || $bankNumberRest === 1){
                $bankNumberDigit = 0;
            } else if($bankNumberRest === 10){
                $bankNumberDigit = 1;
            } else{
                $bankNumberDigit = 11 - $bankNumberRest;
            }
            
            $paramsBillet['bankNumber'] = $paramsBillet['nossoNumero'] . $bankNumberDigit;

            $xmlCreate = $this->getTicketXml($paramsBank, $paramsConsumer, $paramsSale, $paramsBillet);
            $cResponse = $cliTicket->create($xmlCreate);

            // cobrança
            $cliCobranca = new \SoapClient("https://ymbcash.santander.com.br/ymbsrv/CobrancaV3EndpointService/CobrancaV3EndpointService.wsdl", $options);
            $xmlRegistro = $this->getRegistroXml($cResponse->TicketResponse->ticket, $paramsSale, $paramsBillet);
            
            ob_start();
            $rResponse = $cliCobranca->registraTitulo($xmlRegistro);
            $dadosboleto = $this->handleGenerateBillet($paramsBank, $paramsBillet, $paramsClient, $paramsStore, $paramsSale, $obs);

            include(__DIR__ . "/funcoes/santander.php");

            $dadosboleto["codigo_barras"] = $rResponse->return->titulo->cdBarra;
            $dadosboleto["linha_digitavel"] = $rResponse->return->titulo->linDig;

            include(__DIR__ . "/layout/santander.php");
            
            $html = ob_get_clean();
            ob_end_clean();
            
            file_put_contents(__DIR__ . '../../../../../../../../../billets/'.$paramsBillet['nossoNumero'].'.html', $html);

            return array(
                'error'          => null,
                'billetContent'  => $html
            );
        }
        catch(SoapFault $e)
        {
            echo("EXCEÇÂO DO SOAP             ");
            var_dump($e);
        }
    }

    public static function factory() {
        return new self();
    }

    // Impresso no browser:
    /*
    Array ( [TicketRequest] => Array ( [dados] => Array ( [entry] => Array ( [entry1] => Array ( [key] => CONVENIO.COD-BANCO [value] => 0033 ) [entry2] => Array ( [key] => CONVENIO.COD-CONVENIO [value] => 7849036 ) [entry3] => Array ( [key] => PAGADOR.TP-DOC [value] => 02 ) [entry4] => Array ( [key] => PAGADOR.NUM-DOC [value] => 66932165449 ) [entry5] => Array ( [key] => PAGADOR.NOME [value] => Romero Rolim geraBoleto ) [entry6] => Array ( [key] => PAGADOR.ENDER [value] => Rua geraBoleto 1 ) [entry7] => Array ( [key] => PAGADOR.BAIRRO [value] => Centro ) [entry8] => Array ( [key] => PAGADOR.CIDADE [value] => Recife ) [entry9] => Array ( [key] => PAGADOR.UF [value] => PE ) [entry10] => Array ( [key] => PAGADOR.CEP [value] => 50000000 ) [entry11] => Array ( [key] => TITULO.NOSSO-NUMERO [value] => 0000000000005 ) [entry12] => Array ( [key] => TITULO.SEU-NUMERO [value] => 000000000000005 ) [entry13] => Array ( [key] => TITULO.DT-VENCTO [value] => 23022017 ) [entry14] => Array ( [key] => TITULO.DT-EMISSAO [value] => 21022017 ) [entry15] => Array ( [key] => TITULO.ESPECIE [value] => 02 ) [entry16] => Array ( [key] => TITULO.VL-NOMINAL [value] => 000000000000015 ) [entry17] => Array ( [key] => TITULO.PC-MULTA [value] => 000 ) [entry18] => Array ( [key] => TITULO.QT-DIAS-MULTA [value] => 00 ) [entry19] => Array ( [key] => TITULO.PC-JURO [value] => 000 ) [entry20] => Array ( [key] => TITULO.TP-DESC [value] => 0 ) [entry21] => Array ( [key] => TITULO.VL-DESC [value] => 000 ) [entry22] => Array ( [key] => TITULO.DT-LIMI-DESC [value] => 00000000 ) [entry23] => Array ( [key] => TITULO.VL-ABATIMENTO [value] => 000 ) [entry24] => Array ( [key] => TITULO.TP-PROTESTO [value] => 0 ) [entry25] => Array ( [key] => TITULO.QT-DIAS-PROTESTO [value] => 00 ) [entry26] => Array ( [key] => TITULO.QT-DIAS-BAIXA [value] => 1 ) [entry27] => Array ( [key] => MENSAGEM [value] => Sr. Caixa Nao receber apos vencimento nem valor menor que o do documento. ) ) ) [expiracao] => 100 [sistema] => YMB ) )

    Array ( [dto] => Array ( [dtNsu] => 21022017 [estacao] => AAAA [nsu] => TST00000000000000005 [ticket] => /2K1e/KX+u2msniMOChH/BqRVL2ggwX41N/uFoUkRRsvCoU14y2bhCZYR1Vy+sjz/+3aA1ooGDRnLbOMGFgWdkUenrNs6QYmmCuwG2UQZYchzkdSt76wAH62ILGp9Kjk [tpAmbiente] => T ) )

    stdClass Object ( [TicketResponse] => stdClass Object ( [retCode] => 0 [ticket] => /2K1e/KX+u2msniMOChH/BqRVL2ggwX41N/uFoUkRRsvCoU14y2bhCZYR1Vy+sjz/+3aA1ooGDRnLbOMGFgWdkUenrNs6QYmmCuwG2UQZYchzkdSt76wAH62ILGp9Kjk ) )

    stdClass Object ( [return] => stdClass Object ( [codcede] => [convenio] => stdClass Object ( [codBanco] => 0000 [codConv] => 000000000 ) [descricaoErro] => @ERYKE0001 - NMPGD INVALIDO [dtNsu] => 21022017 [estacao] => SIOV [nsu] => TST00000000000000005 [pagador] => stdClass Object ( [bairro] => [cep] => 00000000 [cidade] => [ender] => [nome] => [numDoc] => 000000000000000 [tpDoc] => 00 [uf] => ) [situacao] => 20 [titulo] => stdClass Object ( [aceito] => [cdBarra] => [dtEmissao] => [dtEntr] => [dtLimiDesc] => [dtVencto] => [especie] => 00 [linDig] => [nossoNumero] => 0000000000000 [pcJuro] => 00000 [pcMulta] => 00000 [qtDiasBaixa] => 00 [qtDiasMulta] => 00 [qtDiasProtesto] => 00 [seuNumero] => [tpDesc] => 0 [tpProtesto] => 0 [vlAbatimento] => 000000000000000 [vlDesc] => 000000000000000 [vlNominal] => 000000000000000 ) [tpAmbiente] => T ) )
    */
}