<?php
namespace Zeedhi\PaymentPlatform\InstantBuy;

use Zeedhi\PaymentPlatform\Transaction;
use Zeedhi\PaymentPlatform\Customer;

class InstantBuyTransaction extends Transaction {

    /** @var string */
    private $creditCardToken;
    /** @var Customer */
    private $customer;
    /** @var String */
    private $flag;
    /** @var String */
    private $cvv;
        /** @var String */
    private $items;
    
    /**
     * @param float     $value
     * @param string    $transactionId
     * @param string    $creditCardToken
     * @param Customer  $customer
     */
    public function __construct($value, $transactionId, $creditCardToken, Customer $customer, $nrInstallment = 1) {
        parent::__construct($value, $transactionId, $nrInstallment);
        $this->creditCardToken = $creditCardToken;
        $this->customer = $customer;
    }

    /**
     * @return string
     */
    public function getCreditCardToken() {
        return $this->creditCardToken;
    }
    
    /**
     * @return Customer
     */
    public function getCustomer() {
        return $this->customer;
    }

    /**
     * @param $flag
     */
    public function setFlag($flag){
        $this->flag = $flag;
    }

    /**
     * @return string
     */
    public function getFlag(){
        return $this->flag;
    }
    
    /**
     * @param $cvv
     */
    public function setCvv($cvv){
        $this->cvv = $cvv;
    }

    /**
     * @return string
     */
    public function getCvv(){
        return $this->cvv;
    }

    public function setItems($items) {
        $this->items = $items;
    }

    /**
     * @return Items
     */
    public function getItems() {
        return $this->items;
    }
}