<?php
namespace Zeedhi\PaymentPlatform\InstantBuy;

use  Zeedhi\PaymentPlatform\Customer;

class InstantBuyTransactionTest extends \PHPUnit_Framework_TestCase{

	/** @var InstantBuyTransaction */
	protected $instantBuyTransaction;
	/** @var String */
	protected $value = "100.00";
	/** @var String */
	protected $transactionId = "000001";
	/** @var String */
	protected $creditCardToken = "0000000001-0000002";
	/** @var Int */
	protected $nrInstallment = 1;
	/** @var Customer */
    protected $customer;

	public function setUp(){
        $this->customer =  $this->getMockBuilder(Customer::class)
                            ->setMethods(array())
                            ->disableOriginalConstructor()
                            ->getMock();

		$this->instantBuyTransaction = new InstantBuyTransaction($this->value, $this->transactionId, $this->creditCardToken,  $this->customer, $this->nrInstallment);
	}

	public function testGetCreditCardToken() {
        $this->assertEquals($this->creditCardToken, $this->instantBuyTransaction->getCreditCardToken());
    }

    public function testGetValue() {
        $this->assertEquals($this->value, $this->instantBuyTransaction->getValue());
    }
    
    public function testGetTransactionId() {
        $this->assertEquals($this->transactionId, $this->instantBuyTransaction->getTransactionId());
    }
    
    public function testGetNrInstallment() {
        $this->assertEquals($this->nrInstallment, $this->instantBuyTransaction->getNrInstallment());
    }

    public function testGetCustomer() {
        $this->assertEquals($this->customer, $this->instantBuyTransaction->getCustomer());
    }

}